/*
GEIGER COUNTER final 1.0 beta
17.06.2009
*/

#include <pic1684.h>
#include "delay.c"
#include "lcd.c"

#define LIGHT RA2=1
#define NOLIGHT RA2=0
#define SOUND RA3=1
#define NOSOUND RA3=0

const unsigned char light_time=3;
const char mkR[5]={' ',228,'k','R'};
const char mR[]=" mR ";

unsigned char light, delay, sek, old_sek;
unsigned char i;
unsigned int count;
unsigned long int data, data2, result;
bit c;

main()
{
TRISA=0; //Port A is OUT
TRISB=0b00000011; //Port B 1 - IN, 0 - OUT

T0CS=0;   //    TMR0
INTEDG=1; //    RB0/INT
T0IE=1;   //    TMR0
INTE=1;   //   INT

lcd_init();

PSA=0; PS2=0; PS1=1; PS0=1; //    16
c=0; //  
count=0;
result=0;
delay=0;
sek=39; // 40   (0-39)

LIGHT; // 
TMR0=5;
GIE=1;

 lcd_goto(0); lcd_puts("TOThEMA");
lcd_goto(64); lcd_puts("software");
while (sek>37);

if (!RB1) SOUND; else NOSOUND;
lcd_clear();
lcd_goto(2);lcd_puts("WAIT");
while (sek>29){ lcd_goto(101-sek); lcd_putch(255); }

lcd_clear();
light=light_time;

LOOP:
//:::::::::::::::::::::::::::::::::::::::::::::: key :::::::::::::::::::
if (!RB1) //Light
 {
  LIGHT; 
  light=light_time;
 }
//:::::::::::::::::::::::::::::::::::::::::::::: end of key

//********************************************** program *************************

if (old_sek!=sek) //     
{
  if (!c) //  
    {
      data=result*40/(39-sek);
      switch (sek)
      { case 29: lcd_goto (66); lcd_putch(161); break;
        case 20: lcd_goto (67); lcd_putch(161); break;
        case 10: lcd_goto (68); lcd_putch(161); break;
        case 0: lcd_goto (69); lcd_putch(161); break; }
    }
  else  //  
     {
       data=data2*(40+sek)/80 + result/2;
       switch (sek)
       { case 30: lcd_goto (66); lcd_putch(223); lcd_goto (69); lcd_putch(161); break;
         case 20: lcd_goto (67); lcd_putch(223); lcd_goto (66); lcd_putch(161); break;
         case 10: lcd_goto (68); lcd_putch(223); lcd_goto (67); lcd_putch(161); break;
         case 0: lcd_goto (69); lcd_putch(223); lcd_goto (68); lcd_putch(161); break; }
       
     }

  old_sek=sek;
  lcd_goto(1);
  if (data>999) {lcd_putn (data/999); lcd_puts (mR);}
   else {lcd_putn (data); lcd_puts (mkR);}
  
  if (!light) NOLIGHT;

  
 }
//********************************************** end of program ******************
goto LOOP;
}

//---------------------------------------------- interrupt -----------------------
static void interrupt
isr(void)
{
 if (T0IF){ //  
  T0IF=0;
  TMR0=5;
  delay++;

    if (delay==250) //   1 
     {
      delay=0;
      if (sek) sek--;
       else
        {
         sek=39; //   10 
         if (!c) c=1;
         data2=data;
         result=0;
        }
      result+=count; count=0; //        
      if (light) light--; //    !=0    1 
     }
 }

 if (INTF){ //    
   if (count!=6500) count++;
   INTF=0;
   }
}
//---------------------------------------------- end of interrupt -----------------
